///////////////////////////////////////////////////////////////////////////////
//  Ȩ      : Ȩ (C) Ƽ޹˾
//  ļ    : VariantFactory.cpp
//        : 
//  汾      : V1.0
//        : 2006-03-16
//        : 
//              ļʵCCVariantFactory
//        : 
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
//ͷļİ
#include "common/Common.h"

#include "IPSServer/IPSServerDef.h"
#include "IPSServer/IPSVariant.h"

#include "VariantFactory.h"
#include "VariantI.h"



///////////////////////////////////////////////////////////////////////////////
//ռ
using namespace InfoProcess;




///////////////////////////////////////////////////////////////////////////////
//  :   CVariantFactory::CVariantFactory
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              
//  :   
//              
// ֵ   :   
//              
// ˵ :   
//              캯
// ޸ʷ :   
//                         
///////////////////////////////////////////////////////////////////////////////
CVariantFactory::CVariantFactory()
{
    return;
}


///////////////////////////////////////////////////////////////////////////////
//  :   CVariantFactory::~CVariantFactory
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              
//  :   
//              
// ֵ   :   
//              
// ˵ :   
//              
// ޸ʷ :   
//                         
///////////////////////////////////////////////////////////////////////////////
CVariantFactory::~CVariantFactory()
{
    return;
}


///////////////////////////////////////////////////////////////////////////////
//  :   CVariantFactory::destroy
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              
//  :   
//              
// ֵ   :   
//              
// ˵ :   
//              ʵֻĴ麯--
// ޸ʷ :   
//                         
///////////////////////////////////////////////////////////////////////////////
void CVariantFactory::destroy()
{
    return;
}


///////////////////////////////////////////////////////////////////////////////
//  :   CVariantFactory::create
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              type    ---     Variant
//
//  :   
//              
//
// ֵ   :   Ice::ObjectPtr
//              ָVariantȷĶָ
//
// ˵ :   
//              ָVariantȷĶָ
//
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
Ice::ObjectPtr CVariantFactory::create(const string& type)
{
	if ( "::InfoProcess::VariantBoolean" == type ) 
    {
		return new VariantBooleanI;
	}
    
	if ( "::InfoProcess::VariantByte" == type ) 
    {
		return new VariantByteI;
	}
    
	if ( "::InfoProcess::VariantShort" == type ) 
    {
		return new VariantShortI;
	}
    
	if ( "::InfoProcess::VariantInt" == type ) 
    {
		return new VariantIntI;
	}
    
	if ( "::InfoProcess::VariantLong" == type ) 
    {
		return new VariantLongI;
	}
    
	if ( "::InfoProcess::VariantFloat" == type ) 
    {
		return new VariantFloatI;
	}
    
	if ( "::InfoProcess::VariantDouble" == type ) 
    {
		return new VariantDoubleI;
	}
    
	if ( "::InfoProcess::VariantString" == type ) 
    {
		return new VariantStringI;
	}
    
    if ( "::InfoProcess::VariantCString" == type ) 
    {
        return new VariantCStringI;
    }

	if ( "::InfoProcess::VariantBlob" == type ) 
    {
		return new VariantBlobI;
	}
    
    if ( "::InfoProcess::VariantTime" == type ) 
    {
        return new VariantTimeI;
    }
    
    if ( "::InfoProcess::VariantShortVec" == type ) 
    {
        return new VariantShortVecI;
    }

    if ( "::InfoProcess::VariantIntVec" == type ) 
    {
        return new VariantIntVecI;
    }

    if ( "::InfoProcess::VariantLongVec" == type ) 
    {
        return new VariantLongVecI;
    }

    if ( "::InfoProcess::VariantFloatVec" == type ) 
    {
        return new VariantFloatVecI;
    }
    
    if ( "::InfoProcess::VariantDoubleVec" == type ) 
    {
        return new VariantDoubleVecI;
    }
    
    if ( "::InfoProcess::VariantVarVec" == type ) 
    {
        return new VariantVarVecI;
    }
    
    if ( "::InfoProcess::VariantVarMap" == type ) 
    {
        return new VariantVarMapI;
    }
    
    assert(false); // Should never be reached
    throw;
	
    return IPS_EXIT_SUCCESS;
}


///////////////////////////////////////////////////////////////////////////////
//  :   CVariantFactory::create
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              s               ---     ֵַ
//              vt              ---     ֵ
//              
//  :   
//              
// ֵ   :   VariantPtr
//              ֵָָVariantPtr
//              
// ˵ :   
//              ֵַָʹVariantָ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
VariantPtr CVariantFactory::create(const string& s, const InfoProcess::VARTYPE vt)
{
	Variant* var = NULL;
    
    switch( vt ) 
    {
        case VTBOOL:
		    {
			    var = new VariantBooleanI;
		    }
    	    break;
	    case VTBYTE:
		    {
			    var = new VariantByteI;
		    }
		    break;
	    case VTSHORT:
		    {
			    var = new VariantShortI;
		    }
		    break;
	    case VTINT:
		    {
			    var = new VariantIntI;
		    }
		    break;
	    case VTLONG:
		    {
			    var = new VariantLongI;
		    }
		    break;
	    case VTFLOAT:
		    {
			    var = new VariantFloatI;
		    }
		    break;
	    case VTDOUBLE:
		    {
			    var = new VariantDoubleI;
		    }
		    break;
	    case VTSTRING:
		    {
			    var = new VariantStringI;
		    }
		    break;
        case VTCSTRING:
            {
                var = new VariantCStringI;
            }
            break;
	    case VTBLOB:
		    {
			    var = new VariantBlobI;
		    }
		    break;
        case VTTIME:
            {
                var = new VariantTimeI;
            }
            break;
        case VTSHORTVEC:
            {
                var = new VariantShortVecI;
            }
            break;
        case VTINTVEC:
            {
                var = new VariantIntVecI;
            }
            break;

        case VTLONGVEC:
            {
                var = new VariantLongVecI;
            }
            break;
        case VTFLOATVEC:
            {
                var = new VariantFloatVecI;
            }
            break;
        case VTDOUBLEVEC:
            {
                var = new VariantDoubleVecI;
            }
            break;
        case VTVARVEC:
            {
                var = new VariantVarVecI;
            }
            break;
        case VTVARMAP:
            {
                var = new VariantVarMapI;
            }
            break;
        default:
		    return NULL;
    }
	
    if ( 0 == var->fromString(s) )
    {
		return var;
    }
	else
    {
		return NULL;
    }
}



///////////////////////////////////////////////////////////////////////////////
//  :   CVariantFactory::create
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              bq              ---     ֽбֵ
//              vt              ---     ֵ
//              
//  :   
//              
// ֵ   :   VariantPtr
//              ֵָָVariantPtr
//              
// ˵ :   
//              ָֽиֵʹVariantָ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
VariantPtr CVariantFactory::create(const Ice::ByteSeq& bq, const InfoProcess::VARTYPE vt)
{
    Variant* var = NULL;

    switch( vt ) 
    {
        case VTBOOL:
            {
                var = new VariantBooleanI;
            }
            break;
        case VTBYTE:
            {
                var = new VariantByteI;
            }
            break;
        case VTSHORT:
            {
                var = new VariantShortI;
            }
            break;
        case VTINT:
            {
                var = new VariantIntI;
            }
            break;
        case VTLONG:
            {
                var = new VariantLongI;
            }
            break;
        case VTFLOAT:
            {
                var = new VariantFloatI;
            }
            break;
        case VTDOUBLE:
            {
                var = new VariantDoubleI;
            }
            break;
        case VTSTRING:
            {
                var = new VariantStringI;
            }
            break;
        case VTCSTRING:
            {
                var = new VariantCStringI;
            }
            break;
        case VTBLOB:
            {
                var = new VariantBlobI;
            }
            break;
        case VTTIME:
            {
                var = new VariantTimeI;
            }
            break;
        case VTSHORTVEC:
            {
                var = new VariantShortVecI;
            }
            break;
        case VTINTVEC:
            {
                var = new VariantIntVecI;
            }
            break;
        case VTLONGVEC:
            {
                var = new VariantLongVecI;
            }
            break;
        case VTFLOATVEC:
            {
                var = new VariantFloatVecI;
            }
            break;
        case VTDOUBLEVEC:
            {
                var = new VariantDoubleVecI;
            }
            break;
        case VTVARVEC:
            {
                var = new VariantVarVecI;
            }
            break;
        case VTVARMAP:
            {
                var = new VariantVarMapI;
            }
            break;
        default:
            return NULL;
    }
    
    if ( NULL == var )
    {
        return NULL;
    }
    
    if ( 0 == var->fromByteSeq(bq) )
    {
        return var;
    }
    else
    {
        return NULL;
    }
}



