// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.1.0
// Generated from file `IPSItem.ice'

#include <IPSItem.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 301
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

void
IceInternal::incRef(::InfoProcess::IPSObject* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::InfoProcess::IPSObject* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::InfoProcess::IPSObject* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::InfoProcess::IPSObject* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::InfoProcess::IPSItemDef* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::InfoProcess::IPSItemDef* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::InfoProcess::IPSItemDef* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::InfoProcess::IPSItemDef* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::InfoProcess::IPSItemProperty* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::InfoProcess::IPSItemProperty* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::InfoProcess::IPSItemProperty* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::InfoProcess::IPSItemProperty* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::InfoProcess::PROPERTYDESC* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::InfoProcess::PROPERTYDESC* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::InfoProcess::PROPERTYDESC* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::InfoProcess::PROPERTYDESC* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::InfoProcess::IPSItemState* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::InfoProcess::IPSItemState* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::InfoProcess::IPSItemState* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::InfoProcess::IPSItemState* p)
{
    p->__decRef();
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSObjectPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSObjectPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::InfoProcess::IPSObject;
	v->__copyFrom(proxy);
    }
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSObjectPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemDefPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSItemDefPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::InfoProcess::IPSItemDef;
	v->__copyFrom(proxy);
    }
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemDefPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemPropertyPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSItemPropertyPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::InfoProcess::IPSItemProperty;
	v->__copyFrom(proxy);
    }
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemPropertyPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::PROPERTYDESCPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::PROPERTYDESCPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::InfoProcess::PROPERTYDESC;
	v->__copyFrom(proxy);
    }
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::PROPERTYDESCPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemStatePrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSItemStatePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::InfoProcess::IPSItemState;
	v->__copyFrom(proxy);
    }
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemStatePtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
InfoProcess::__addObject(const IPSObjectPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
InfoProcess::__usesClasses(const IPSObjectPtr& p)
{
    return p->__usesClasses();
}

void
InfoProcess::__decRefUnsafe(IPSObjectPtr& p)
{
    p->__decRefUnsafe();
}

void
InfoProcess::__clearHandleUnsafe(IPSObjectPtr& p)
{
    p.__clearHandleUnsafe();
}

void
InfoProcess::__addObject(const IPSItemDefPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
InfoProcess::__usesClasses(const IPSItemDefPtr& p)
{
    return p->__usesClasses();
}

void
InfoProcess::__decRefUnsafe(IPSItemDefPtr& p)
{
    p->__decRefUnsafe();
}

void
InfoProcess::__clearHandleUnsafe(IPSItemDefPtr& p)
{
    p.__clearHandleUnsafe();
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemDefPtr* begin, const ::InfoProcess::IPSItemDefPtr* end, ::InfoProcess::__U__IPSItemDefSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
	::InfoProcess::__write(__os, begin[i]);
    }
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSItemDefSeq& v, ::InfoProcess::__U__IPSItemDefSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
	__is->read(::InfoProcess::__patch__IPSItemDefPtr, &v[i]);
	__is->checkSeq();
	__is->endElement();
    }
    __is->endSeq(sz);
}

void
InfoProcess::__addObject(const IPSItemPropertyPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
InfoProcess::__usesClasses(const IPSItemPropertyPtr& p)
{
    return p->__usesClasses();
}

void
InfoProcess::__decRefUnsafe(IPSItemPropertyPtr& p)
{
    p->__decRefUnsafe();
}

void
InfoProcess::__clearHandleUnsafe(IPSItemPropertyPtr& p)
{
    p.__clearHandleUnsafe();
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemPropertyPtr* begin, const ::InfoProcess::IPSItemPropertyPtr* end, ::InfoProcess::__U__IPSItemPropertySeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
	::InfoProcess::__write(__os, begin[i]);
    }
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSItemPropertySeq& v, ::InfoProcess::__U__IPSItemPropertySeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
	__is->read(::InfoProcess::__patch__IPSItemPropertyPtr, &v[i]);
	__is->checkSeq();
	__is->endElement();
    }
    __is->endSeq(sz);
}

void
InfoProcess::__addObject(const PROPERTYDESCPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
InfoProcess::__usesClasses(const PROPERTYDESCPtr& p)
{
    return p->__usesClasses();
}

void
InfoProcess::__decRefUnsafe(PROPERTYDESCPtr& p)
{
    p->__decRefUnsafe();
}

void
InfoProcess::__clearHandleUnsafe(PROPERTYDESCPtr& p)
{
    p.__clearHandleUnsafe();
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::PropertyDescDict& v, ::InfoProcess::__U__PropertyDescDict)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::InfoProcess::PropertyDescDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
	__os->write(p->first);
	::InfoProcess::__write(__os, p->second);
    }
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::PropertyDescDict& v, ::InfoProcess::__U__PropertyDescDict)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
	::std::pair<const  ::Ice::Int, ::InfoProcess::PROPERTYDESCPtr> pair;
	__is->read(const_cast< ::Ice::Int&>(pair.first));
	::InfoProcess::PropertyDescDict::iterator __i = v.insert(v.end(), pair);
	__is->read(::InfoProcess::__patch__PROPERTYDESCPtr, &__i->second);
    }
}

void
InfoProcess::__addObject(const IPSItemStatePtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
InfoProcess::__usesClasses(const IPSItemStatePtr& p)
{
    return p->__usesClasses();
}

void
InfoProcess::__decRefUnsafe(IPSItemStatePtr& p)
{
    p->__decRefUnsafe();
}

void
InfoProcess::__clearHandleUnsafe(IPSItemStatePtr& p)
{
    p.__clearHandleUnsafe();
}

void
InfoProcess::__write(::IceInternal::BasicStream* __os, const ::InfoProcess::IPSItemStatePtr* begin, const ::InfoProcess::IPSItemStatePtr* end, ::InfoProcess::__U__IPSItemStateSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
	::InfoProcess::__write(__os, begin[i]);
    }
}

void
InfoProcess::__read(::IceInternal::BasicStream* __is, ::InfoProcess::IPSItemStateSeq& v, ::InfoProcess::__U__IPSItemStateSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
	__is->read(::InfoProcess::__patch__IPSItemStatePtr, &v[i]);
	__is->checkSeq();
	__is->endElement();
    }
    __is->endSeq(sz);
}

const ::std::string&
IceProxy::InfoProcess::IPSObject::ice_staticId()
{
    return ::InfoProcess::IPSObject::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::InfoProcess::IPSObject::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::InfoProcess::IPSObject);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::InfoProcess::IPSObject::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::InfoProcess::IPSObject);
}

bool
IceProxy::InfoProcess::operator==(const ::IceProxy::InfoProcess::IPSObject& l, const ::IceProxy::InfoProcess::IPSObject& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator!=(const ::IceProxy::InfoProcess::IPSObject& l, const ::IceProxy::InfoProcess::IPSObject& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<(const ::IceProxy::InfoProcess::IPSObject& l, const ::IceProxy::InfoProcess::IPSObject& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<=(const ::IceProxy::InfoProcess::IPSObject& l, const ::IceProxy::InfoProcess::IPSObject& r)
{
    return l < r || l == r;
}

bool
IceProxy::InfoProcess::operator>(const ::IceProxy::InfoProcess::IPSObject& l, const ::IceProxy::InfoProcess::IPSObject& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::InfoProcess::operator>=(const ::IceProxy::InfoProcess::IPSObject& l, const ::IceProxy::InfoProcess::IPSObject& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::InfoProcess::IPSItemDef::ice_staticId()
{
    return ::InfoProcess::IPSItemDef::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::InfoProcess::IPSItemDef::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::InfoProcess::IPSItemDef);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::InfoProcess::IPSItemDef::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::InfoProcess::IPSItemDef);
}

bool
IceProxy::InfoProcess::operator==(const ::IceProxy::InfoProcess::IPSItemDef& l, const ::IceProxy::InfoProcess::IPSItemDef& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator!=(const ::IceProxy::InfoProcess::IPSItemDef& l, const ::IceProxy::InfoProcess::IPSItemDef& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<(const ::IceProxy::InfoProcess::IPSItemDef& l, const ::IceProxy::InfoProcess::IPSItemDef& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<=(const ::IceProxy::InfoProcess::IPSItemDef& l, const ::IceProxy::InfoProcess::IPSItemDef& r)
{
    return l < r || l == r;
}

bool
IceProxy::InfoProcess::operator>(const ::IceProxy::InfoProcess::IPSItemDef& l, const ::IceProxy::InfoProcess::IPSItemDef& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::InfoProcess::operator>=(const ::IceProxy::InfoProcess::IPSItemDef& l, const ::IceProxy::InfoProcess::IPSItemDef& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::InfoProcess::IPSItemProperty::ice_staticId()
{
    return ::InfoProcess::IPSItemProperty::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::InfoProcess::IPSItemProperty::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::InfoProcess::IPSItemProperty);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::InfoProcess::IPSItemProperty::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::InfoProcess::IPSItemProperty);
}

bool
IceProxy::InfoProcess::operator==(const ::IceProxy::InfoProcess::IPSItemProperty& l, const ::IceProxy::InfoProcess::IPSItemProperty& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator!=(const ::IceProxy::InfoProcess::IPSItemProperty& l, const ::IceProxy::InfoProcess::IPSItemProperty& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<(const ::IceProxy::InfoProcess::IPSItemProperty& l, const ::IceProxy::InfoProcess::IPSItemProperty& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<=(const ::IceProxy::InfoProcess::IPSItemProperty& l, const ::IceProxy::InfoProcess::IPSItemProperty& r)
{
    return l < r || l == r;
}

bool
IceProxy::InfoProcess::operator>(const ::IceProxy::InfoProcess::IPSItemProperty& l, const ::IceProxy::InfoProcess::IPSItemProperty& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::InfoProcess::operator>=(const ::IceProxy::InfoProcess::IPSItemProperty& l, const ::IceProxy::InfoProcess::IPSItemProperty& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::InfoProcess::PROPERTYDESC::ice_staticId()
{
    return ::InfoProcess::PROPERTYDESC::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::InfoProcess::PROPERTYDESC::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::InfoProcess::PROPERTYDESC);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::InfoProcess::PROPERTYDESC::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::InfoProcess::PROPERTYDESC);
}

bool
IceProxy::InfoProcess::operator==(const ::IceProxy::InfoProcess::PROPERTYDESC& l, const ::IceProxy::InfoProcess::PROPERTYDESC& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator!=(const ::IceProxy::InfoProcess::PROPERTYDESC& l, const ::IceProxy::InfoProcess::PROPERTYDESC& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<(const ::IceProxy::InfoProcess::PROPERTYDESC& l, const ::IceProxy::InfoProcess::PROPERTYDESC& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<=(const ::IceProxy::InfoProcess::PROPERTYDESC& l, const ::IceProxy::InfoProcess::PROPERTYDESC& r)
{
    return l < r || l == r;
}

bool
IceProxy::InfoProcess::operator>(const ::IceProxy::InfoProcess::PROPERTYDESC& l, const ::IceProxy::InfoProcess::PROPERTYDESC& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::InfoProcess::operator>=(const ::IceProxy::InfoProcess::PROPERTYDESC& l, const ::IceProxy::InfoProcess::PROPERTYDESC& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::InfoProcess::IPSItemState::ice_staticId()
{
    return ::InfoProcess::IPSItemState::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::InfoProcess::IPSItemState::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::InfoProcess::IPSItemState);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::InfoProcess::IPSItemState::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::InfoProcess::IPSItemState);
}

bool
IceProxy::InfoProcess::operator==(const ::IceProxy::InfoProcess::IPSItemState& l, const ::IceProxy::InfoProcess::IPSItemState& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator!=(const ::IceProxy::InfoProcess::IPSItemState& l, const ::IceProxy::InfoProcess::IPSItemState& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<(const ::IceProxy::InfoProcess::IPSItemState& l, const ::IceProxy::InfoProcess::IPSItemState& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::InfoProcess::operator<=(const ::IceProxy::InfoProcess::IPSItemState& l, const ::IceProxy::InfoProcess::IPSItemState& r)
{
    return l < r || l == r;
}

bool
IceProxy::InfoProcess::operator>(const ::IceProxy::InfoProcess::IPSItemState& l, const ::IceProxy::InfoProcess::IPSItemState& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::InfoProcess::operator>=(const ::IceProxy::InfoProcess::IPSItemState& l, const ::IceProxy::InfoProcess::IPSItemState& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
InfoProcess::IPSObject::ice_clone() const
{
    ::InfoProcess::IPSObjectPtr __p = new ::InfoProcess::IPSObject(*this);
    return __p;
}

static const ::std::string __InfoProcess__IPSObject_ids[2] =
{
    "::Ice::Object",
    "::InfoProcess::IPSObject"
};

bool
InfoProcess::IPSObject::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__InfoProcess__IPSObject_ids, __InfoProcess__IPSObject_ids + 2, _s);
}

::std::vector< ::std::string>
InfoProcess::IPSObject::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__InfoProcess__IPSObject_ids[0], &__InfoProcess__IPSObject_ids[2]);
}

const ::std::string&
InfoProcess::IPSObject::ice_id(const ::Ice::Current&) const
{
    return __InfoProcess__IPSObject_ids[1];
}

const ::std::string&
InfoProcess::IPSObject::ice_staticId()
{
    return __InfoProcess__IPSObject_ids[1];
}

void
InfoProcess::IPSObject::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
InfoProcess::IPSObject::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
InfoProcess::IPSObject::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSObject was not generated with stream support";
    throw ex;
}

void
InfoProcess::IPSObject::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSObject was not generated with stream support";
    throw ex;
}

class __F__InfoProcess__IPSObject : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
	assert(type == ::InfoProcess::IPSObject::ice_staticId());
	return new ::InfoProcess::IPSObject;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__InfoProcess__IPSObject_Ptr = new __F__InfoProcess__IPSObject;

const ::Ice::ObjectFactoryPtr&
InfoProcess::IPSObject::ice_factory()
{
    return __F__InfoProcess__IPSObject_Ptr;
}

class __F__InfoProcess__IPSObject__Init
{
public:

    __F__InfoProcess__IPSObject__Init()
    {
	::IceInternal::factoryTable->addObjectFactory(::InfoProcess::IPSObject::ice_staticId(), ::InfoProcess::IPSObject::ice_factory());
    }

    ~__F__InfoProcess__IPSObject__Init()
    {
	::IceInternal::factoryTable->removeObjectFactory(::InfoProcess::IPSObject::ice_staticId());
    }
};

static __F__InfoProcess__IPSObject__Init __F__InfoProcess__IPSObject__i;

#ifdef __APPLE__
extern "C" { void __F__InfoProcess__IPSObject__initializer() {} }
#endif

void 
InfoProcess::__patch__IPSObjectPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::InfoProcess::IPSObjectPtr* p = static_cast< ::InfoProcess::IPSObjectPtr*>(__addr);
    assert(p);
    *p = ::InfoProcess::IPSObjectPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::InfoProcess::IPSObject::ice_staticId();
	throw e;
    }
}

bool
InfoProcess::operator==(const ::InfoProcess::IPSObject& l, const ::InfoProcess::IPSObject& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator!=(const ::InfoProcess::IPSObject& l, const ::InfoProcess::IPSObject& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<(const ::InfoProcess::IPSObject& l, const ::InfoProcess::IPSObject& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<=(const ::InfoProcess::IPSObject& l, const ::InfoProcess::IPSObject& r)
{
    return l < r || l == r;
}

bool
InfoProcess::operator>(const ::InfoProcess::IPSObject& l, const ::InfoProcess::IPSObject& r)
{
    return !(l < r) && !(l == r);
}

bool
InfoProcess::operator>=(const ::InfoProcess::IPSObject& l, const ::InfoProcess::IPSObject& r)
{
    return !(l < r);
}

InfoProcess::IPSItemDef::IPSItemDef(const ::std::string& __ice_szItemID, const ::std::string& __ice_szDispName, bool __ice_bActive, const ::InfoProcess::VariantPtr& __ice_vValue, ::InfoProcess::VARTYPE __ice_vtRequestedDataType) :
    szItemID(__ice_szItemID),
    szDispName(__ice_szDispName),
    bActive(__ice_bActive),
    vValue(__ice_vValue),
    vtRequestedDataType(__ice_vtRequestedDataType)
{
}

::Ice::ObjectPtr
InfoProcess::IPSItemDef::ice_clone() const
{
    ::InfoProcess::IPSItemDefPtr __p = new ::InfoProcess::IPSItemDef(*this);
    return __p;
}

static const ::std::string __InfoProcess__IPSItemDef_ids[3] =
{
    "::Ice::Object",
    "::InfoProcess::IPSItemDef",
    "::InfoProcess::IPSObject"
};

bool
InfoProcess::IPSItemDef::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__InfoProcess__IPSItemDef_ids, __InfoProcess__IPSItemDef_ids + 3, _s);
}

::std::vector< ::std::string>
InfoProcess::IPSItemDef::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__InfoProcess__IPSItemDef_ids[0], &__InfoProcess__IPSItemDef_ids[3]);
}

const ::std::string&
InfoProcess::IPSItemDef::ice_id(const ::Ice::Current&) const
{
    return __InfoProcess__IPSItemDef_ids[1];
}

const ::std::string&
InfoProcess::IPSItemDef::ice_staticId()
{
    return __InfoProcess__IPSItemDef_ids[1];
}

void
InfoProcess::IPSItemDef::__incRef()
{
    IceInternal::gcRecMutex._m->lock();
    assert(_ref >= 0);
    if(_ref == 0)
    {
#ifdef NDEBUG // To avoid annoying warnings about variables that are not used...
	IceInternal::gcObjects.insert(this);
#else
	std::pair<IceInternal::GCObjectSet::iterator, bool> rc = IceInternal::gcObjects.insert(this);
	assert(rc.second);
#endif
    }
    ++_ref;
    IceInternal::gcRecMutex._m->unlock();
}

void
InfoProcess::IPSItemDef::__decRef()
{
    IceInternal::gcRecMutex._m->lock();
    bool doDelete = false;
    assert(_ref > 0);
    if(--_ref == 0)
    {
	doDelete = !_noDelete;
	_noDelete = true;
#ifdef NDEBUG // To avoid annoying warnings about variables that are not used...
	IceInternal::gcObjects.erase(this);
#else
	IceInternal::GCObjectSet::size_type num = IceInternal::gcObjects.erase(this);
	assert(num == 1);
#endif
    }
    IceInternal::gcRecMutex._m->unlock();
    if(doDelete)
    {
	delete this;
    }
}

void
InfoProcess::IPSItemDef::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
	_c[this] = 1;
    }
    else
    {
	++pos->second;
    }
}

bool
InfoProcess::IPSItemDef::__usesClasses()
{
    return true;
}

void
InfoProcess::IPSItemDef::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    if(vValue)
    {
	::InfoProcess::__addObject(vValue, _c);
    }
}

void
InfoProcess::IPSItemDef::__gcClear()
{
    if(vValue)
    {
	if(::InfoProcess::__usesClasses(vValue))
	{
	    ::InfoProcess::__decRefUnsafe(vValue);
	    ::InfoProcess::__clearHandleUnsafe(vValue);
	}
	else
	{
	    vValue = 0;
	}
    }
}

void
InfoProcess::IPSItemDef::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(szItemID);
    __os->write(szDispName);
    __os->write(bActive);
    ::InfoProcess::__write(__os, vValue);
    ::InfoProcess::__write(__os, vtRequestedDataType);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__write(__os);
#else
    ::InfoProcess::IPSObject::__write(__os);
#endif
}

void
InfoProcess::IPSItemDef::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(szItemID);
    __is->read(szDispName);
    __is->read(bActive);
    __is->read(::InfoProcess::__patch__VariantPtr, &vValue);
    ::InfoProcess::__read(__is, vtRequestedDataType);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__read(__is, true);
#else
    ::InfoProcess::IPSObject::__read(__is, true);
#endif
}

void
InfoProcess::IPSItemDef::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSItemDef was not generated with stream support";
    throw ex;
}

void
InfoProcess::IPSItemDef::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSItemDef was not generated with stream support";
    throw ex;
}

class __F__InfoProcess__IPSItemDef : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
	assert(type == ::InfoProcess::IPSItemDef::ice_staticId());
	return new ::InfoProcess::IPSItemDef;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__InfoProcess__IPSItemDef_Ptr = new __F__InfoProcess__IPSItemDef;

const ::Ice::ObjectFactoryPtr&
InfoProcess::IPSItemDef::ice_factory()
{
    return __F__InfoProcess__IPSItemDef_Ptr;
}

class __F__InfoProcess__IPSItemDef__Init
{
public:

    __F__InfoProcess__IPSItemDef__Init()
    {
	::IceInternal::factoryTable->addObjectFactory(::InfoProcess::IPSItemDef::ice_staticId(), ::InfoProcess::IPSItemDef::ice_factory());
    }

    ~__F__InfoProcess__IPSItemDef__Init()
    {
	::IceInternal::factoryTable->removeObjectFactory(::InfoProcess::IPSItemDef::ice_staticId());
    }
};

static __F__InfoProcess__IPSItemDef__Init __F__InfoProcess__IPSItemDef__i;

#ifdef __APPLE__
extern "C" { void __F__InfoProcess__IPSItemDef__initializer() {} }
#endif

void 
InfoProcess::__patch__IPSItemDefPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::InfoProcess::IPSItemDefPtr* p = static_cast< ::InfoProcess::IPSItemDefPtr*>(__addr);
    assert(p);
    *p = ::InfoProcess::IPSItemDefPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::InfoProcess::IPSItemDef::ice_staticId();
	throw e;
    }
}

bool
InfoProcess::operator==(const ::InfoProcess::IPSItemDef& l, const ::InfoProcess::IPSItemDef& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator!=(const ::InfoProcess::IPSItemDef& l, const ::InfoProcess::IPSItemDef& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<(const ::InfoProcess::IPSItemDef& l, const ::InfoProcess::IPSItemDef& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<=(const ::InfoProcess::IPSItemDef& l, const ::InfoProcess::IPSItemDef& r)
{
    return l < r || l == r;
}

bool
InfoProcess::operator>(const ::InfoProcess::IPSItemDef& l, const ::InfoProcess::IPSItemDef& r)
{
    return !(l < r) && !(l == r);
}

bool
InfoProcess::operator>=(const ::InfoProcess::IPSItemDef& l, const ::InfoProcess::IPSItemDef& r)
{
    return !(l < r);
}

InfoProcess::IPSItemProperty::IPSItemProperty(::InfoProcess::VARTYPE __ice_vtDataType, ::Ice::Int __ice_nPropertyID, const ::std::string& __ice_szItemID, const ::std::string& __ice_szDescription, const ::InfoProcess::VariantPtr& __ice_vValue) :
    vtDataType(__ice_vtDataType),
    nPropertyID(__ice_nPropertyID),
    szItemID(__ice_szItemID),
    szDescription(__ice_szDescription),
    vValue(__ice_vValue)
{
}

::Ice::ObjectPtr
InfoProcess::IPSItemProperty::ice_clone() const
{
    ::InfoProcess::IPSItemPropertyPtr __p = new ::InfoProcess::IPSItemProperty(*this);
    return __p;
}

static const ::std::string __InfoProcess__IPSItemProperty_ids[3] =
{
    "::Ice::Object",
    "::InfoProcess::IPSItemProperty",
    "::InfoProcess::IPSObject"
};

bool
InfoProcess::IPSItemProperty::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__InfoProcess__IPSItemProperty_ids, __InfoProcess__IPSItemProperty_ids + 3, _s);
}

::std::vector< ::std::string>
InfoProcess::IPSItemProperty::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__InfoProcess__IPSItemProperty_ids[0], &__InfoProcess__IPSItemProperty_ids[3]);
}

const ::std::string&
InfoProcess::IPSItemProperty::ice_id(const ::Ice::Current&) const
{
    return __InfoProcess__IPSItemProperty_ids[1];
}

const ::std::string&
InfoProcess::IPSItemProperty::ice_staticId()
{
    return __InfoProcess__IPSItemProperty_ids[1];
}

void
InfoProcess::IPSItemProperty::__incRef()
{
    IceInternal::gcRecMutex._m->lock();
    assert(_ref >= 0);
    if(_ref == 0)
    {
#ifdef NDEBUG // To avoid annoying warnings about variables that are not used...
	IceInternal::gcObjects.insert(this);
#else
	std::pair<IceInternal::GCObjectSet::iterator, bool> rc = IceInternal::gcObjects.insert(this);
	assert(rc.second);
#endif
    }
    ++_ref;
    IceInternal::gcRecMutex._m->unlock();
}

void
InfoProcess::IPSItemProperty::__decRef()
{
    IceInternal::gcRecMutex._m->lock();
    bool doDelete = false;
    assert(_ref > 0);
    if(--_ref == 0)
    {
	doDelete = !_noDelete;
	_noDelete = true;
#ifdef NDEBUG // To avoid annoying warnings about variables that are not used...
	IceInternal::gcObjects.erase(this);
#else
	IceInternal::GCObjectSet::size_type num = IceInternal::gcObjects.erase(this);
	assert(num == 1);
#endif
    }
    IceInternal::gcRecMutex._m->unlock();
    if(doDelete)
    {
	delete this;
    }
}

void
InfoProcess::IPSItemProperty::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
	_c[this] = 1;
    }
    else
    {
	++pos->second;
    }
}

bool
InfoProcess::IPSItemProperty::__usesClasses()
{
    return true;
}

void
InfoProcess::IPSItemProperty::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    if(vValue)
    {
	::InfoProcess::__addObject(vValue, _c);
    }
}

void
InfoProcess::IPSItemProperty::__gcClear()
{
    if(vValue)
    {
	if(::InfoProcess::__usesClasses(vValue))
	{
	    ::InfoProcess::__decRefUnsafe(vValue);
	    ::InfoProcess::__clearHandleUnsafe(vValue);
	}
	else
	{
	    vValue = 0;
	}
    }
}

void
InfoProcess::IPSItemProperty::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    ::InfoProcess::__write(__os, vtDataType);
    __os->write(nPropertyID);
    __os->write(szItemID);
    __os->write(szDescription);
    ::InfoProcess::__write(__os, vValue);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__write(__os);
#else
    ::InfoProcess::IPSObject::__write(__os);
#endif
}

void
InfoProcess::IPSItemProperty::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::InfoProcess::__read(__is, vtDataType);
    __is->read(nPropertyID);
    __is->read(szItemID);
    __is->read(szDescription);
    __is->read(::InfoProcess::__patch__VariantPtr, &vValue);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__read(__is, true);
#else
    ::InfoProcess::IPSObject::__read(__is, true);
#endif
}

void
InfoProcess::IPSItemProperty::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSItemProperty was not generated with stream support";
    throw ex;
}

void
InfoProcess::IPSItemProperty::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSItemProperty was not generated with stream support";
    throw ex;
}

class __F__InfoProcess__IPSItemProperty : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
	assert(type == ::InfoProcess::IPSItemProperty::ice_staticId());
	return new ::InfoProcess::IPSItemProperty;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__InfoProcess__IPSItemProperty_Ptr = new __F__InfoProcess__IPSItemProperty;

const ::Ice::ObjectFactoryPtr&
InfoProcess::IPSItemProperty::ice_factory()
{
    return __F__InfoProcess__IPSItemProperty_Ptr;
}

class __F__InfoProcess__IPSItemProperty__Init
{
public:

    __F__InfoProcess__IPSItemProperty__Init()
    {
	::IceInternal::factoryTable->addObjectFactory(::InfoProcess::IPSItemProperty::ice_staticId(), ::InfoProcess::IPSItemProperty::ice_factory());
    }

    ~__F__InfoProcess__IPSItemProperty__Init()
    {
	::IceInternal::factoryTable->removeObjectFactory(::InfoProcess::IPSItemProperty::ice_staticId());
    }
};

static __F__InfoProcess__IPSItemProperty__Init __F__InfoProcess__IPSItemProperty__i;

#ifdef __APPLE__
extern "C" { void __F__InfoProcess__IPSItemProperty__initializer() {} }
#endif

void 
InfoProcess::__patch__IPSItemPropertyPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::InfoProcess::IPSItemPropertyPtr* p = static_cast< ::InfoProcess::IPSItemPropertyPtr*>(__addr);
    assert(p);
    *p = ::InfoProcess::IPSItemPropertyPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::InfoProcess::IPSItemProperty::ice_staticId();
	throw e;
    }
}

bool
InfoProcess::operator==(const ::InfoProcess::IPSItemProperty& l, const ::InfoProcess::IPSItemProperty& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator!=(const ::InfoProcess::IPSItemProperty& l, const ::InfoProcess::IPSItemProperty& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<(const ::InfoProcess::IPSItemProperty& l, const ::InfoProcess::IPSItemProperty& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<=(const ::InfoProcess::IPSItemProperty& l, const ::InfoProcess::IPSItemProperty& r)
{
    return l < r || l == r;
}

bool
InfoProcess::operator>(const ::InfoProcess::IPSItemProperty& l, const ::InfoProcess::IPSItemProperty& r)
{
    return !(l < r) && !(l == r);
}

bool
InfoProcess::operator>=(const ::InfoProcess::IPSItemProperty& l, const ::InfoProcess::IPSItemProperty& r)
{
    return !(l < r);
}

InfoProcess::PROPERTYDESC::PROPERTYDESC(const ::std::string& __ice_Desc, ::InfoProcess::VARTYPE __ice_Type) :
    Desc(__ice_Desc),
    Type(__ice_Type)
{
}

::Ice::ObjectPtr
InfoProcess::PROPERTYDESC::ice_clone() const
{
    ::InfoProcess::PROPERTYDESCPtr __p = new ::InfoProcess::PROPERTYDESC(*this);
    return __p;
}

static const ::std::string __InfoProcess__PROPERTYDESC_ids[3] =
{
    "::Ice::Object",
    "::InfoProcess::IPSObject",
    "::InfoProcess::PROPERTYDESC"
};

bool
InfoProcess::PROPERTYDESC::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__InfoProcess__PROPERTYDESC_ids, __InfoProcess__PROPERTYDESC_ids + 3, _s);
}

::std::vector< ::std::string>
InfoProcess::PROPERTYDESC::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__InfoProcess__PROPERTYDESC_ids[0], &__InfoProcess__PROPERTYDESC_ids[3]);
}

const ::std::string&
InfoProcess::PROPERTYDESC::ice_id(const ::Ice::Current&) const
{
    return __InfoProcess__PROPERTYDESC_ids[2];
}

const ::std::string&
InfoProcess::PROPERTYDESC::ice_staticId()
{
    return __InfoProcess__PROPERTYDESC_ids[2];
}

void
InfoProcess::PROPERTYDESC::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(Desc);
    ::InfoProcess::__write(__os, Type);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__write(__os);
#else
    ::InfoProcess::IPSObject::__write(__os);
#endif
}

void
InfoProcess::PROPERTYDESC::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(Desc);
    ::InfoProcess::__read(__is, Type);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__read(__is, true);
#else
    ::InfoProcess::IPSObject::__read(__is, true);
#endif
}

void
InfoProcess::PROPERTYDESC::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::PROPERTYDESC was not generated with stream support";
    throw ex;
}

void
InfoProcess::PROPERTYDESC::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::PROPERTYDESC was not generated with stream support";
    throw ex;
}

class __F__InfoProcess__PROPERTYDESC : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
	assert(type == ::InfoProcess::PROPERTYDESC::ice_staticId());
	return new ::InfoProcess::PROPERTYDESC;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__InfoProcess__PROPERTYDESC_Ptr = new __F__InfoProcess__PROPERTYDESC;

const ::Ice::ObjectFactoryPtr&
InfoProcess::PROPERTYDESC::ice_factory()
{
    return __F__InfoProcess__PROPERTYDESC_Ptr;
}

class __F__InfoProcess__PROPERTYDESC__Init
{
public:

    __F__InfoProcess__PROPERTYDESC__Init()
    {
	::IceInternal::factoryTable->addObjectFactory(::InfoProcess::PROPERTYDESC::ice_staticId(), ::InfoProcess::PROPERTYDESC::ice_factory());
    }

    ~__F__InfoProcess__PROPERTYDESC__Init()
    {
	::IceInternal::factoryTable->removeObjectFactory(::InfoProcess::PROPERTYDESC::ice_staticId());
    }
};

static __F__InfoProcess__PROPERTYDESC__Init __F__InfoProcess__PROPERTYDESC__i;

#ifdef __APPLE__
extern "C" { void __F__InfoProcess__PROPERTYDESC__initializer() {} }
#endif

void 
InfoProcess::__patch__PROPERTYDESCPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::InfoProcess::PROPERTYDESCPtr* p = static_cast< ::InfoProcess::PROPERTYDESCPtr*>(__addr);
    assert(p);
    *p = ::InfoProcess::PROPERTYDESCPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::InfoProcess::PROPERTYDESC::ice_staticId();
	throw e;
    }
}

bool
InfoProcess::operator==(const ::InfoProcess::PROPERTYDESC& l, const ::InfoProcess::PROPERTYDESC& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator!=(const ::InfoProcess::PROPERTYDESC& l, const ::InfoProcess::PROPERTYDESC& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<(const ::InfoProcess::PROPERTYDESC& l, const ::InfoProcess::PROPERTYDESC& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<=(const ::InfoProcess::PROPERTYDESC& l, const ::InfoProcess::PROPERTYDESC& r)
{
    return l < r || l == r;
}

bool
InfoProcess::operator>(const ::InfoProcess::PROPERTYDESC& l, const ::InfoProcess::PROPERTYDESC& r)
{
    return !(l < r) && !(l == r);
}

bool
InfoProcess::operator>=(const ::InfoProcess::PROPERTYDESC& l, const ::InfoProcess::PROPERTYDESC& r)
{
    return !(l < r);
}

InfoProcess::IPSItemState::IPSItemState(const ::std::string& __ice_szItemID, ::Ice::Long __ice_lTimeStamp, ::Ice::Int __ice_nQuality, const ::InfoProcess::VariantPtr& __ice_vDataValue) :
    szItemID(__ice_szItemID),
    lTimeStamp(__ice_lTimeStamp),
    nQuality(__ice_nQuality),
    vDataValue(__ice_vDataValue)
{
}

::Ice::ObjectPtr
InfoProcess::IPSItemState::ice_clone() const
{
    ::InfoProcess::IPSItemStatePtr __p = new ::InfoProcess::IPSItemState(*this);
    return __p;
}

static const ::std::string __InfoProcess__IPSItemState_ids[3] =
{
    "::Ice::Object",
    "::InfoProcess::IPSItemState",
    "::InfoProcess::IPSObject"
};

bool
InfoProcess::IPSItemState::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__InfoProcess__IPSItemState_ids, __InfoProcess__IPSItemState_ids + 3, _s);
}

::std::vector< ::std::string>
InfoProcess::IPSItemState::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__InfoProcess__IPSItemState_ids[0], &__InfoProcess__IPSItemState_ids[3]);
}

const ::std::string&
InfoProcess::IPSItemState::ice_id(const ::Ice::Current&) const
{
    return __InfoProcess__IPSItemState_ids[1];
}

const ::std::string&
InfoProcess::IPSItemState::ice_staticId()
{
    return __InfoProcess__IPSItemState_ids[1];
}

void
InfoProcess::IPSItemState::__incRef()
{
    IceInternal::gcRecMutex._m->lock();
    assert(_ref >= 0);
    if(_ref == 0)
    {
#ifdef NDEBUG // To avoid annoying warnings about variables that are not used...
	IceInternal::gcObjects.insert(this);
#else
	std::pair<IceInternal::GCObjectSet::iterator, bool> rc = IceInternal::gcObjects.insert(this);
	assert(rc.second);
#endif
    }
    ++_ref;
    IceInternal::gcRecMutex._m->unlock();
}

void
InfoProcess::IPSItemState::__decRef()
{
    IceInternal::gcRecMutex._m->lock();
    bool doDelete = false;
    assert(_ref > 0);
    if(--_ref == 0)
    {
	doDelete = !_noDelete;
	_noDelete = true;
#ifdef NDEBUG // To avoid annoying warnings about variables that are not used...
	IceInternal::gcObjects.erase(this);
#else
	IceInternal::GCObjectSet::size_type num = IceInternal::gcObjects.erase(this);
	assert(num == 1);
#endif
    }
    IceInternal::gcRecMutex._m->unlock();
    if(doDelete)
    {
	delete this;
    }
}

void
InfoProcess::IPSItemState::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
	_c[this] = 1;
    }
    else
    {
	++pos->second;
    }
}

bool
InfoProcess::IPSItemState::__usesClasses()
{
    return true;
}

void
InfoProcess::IPSItemState::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    if(vDataValue)
    {
	::InfoProcess::__addObject(vDataValue, _c);
    }
}

void
InfoProcess::IPSItemState::__gcClear()
{
    if(vDataValue)
    {
	if(::InfoProcess::__usesClasses(vDataValue))
	{
	    ::InfoProcess::__decRefUnsafe(vDataValue);
	    ::InfoProcess::__clearHandleUnsafe(vDataValue);
	}
	else
	{
	    vDataValue = 0;
	}
    }
}

void
InfoProcess::IPSItemState::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(szItemID);
    __os->write(lTimeStamp);
    __os->write(nQuality);
    ::InfoProcess::__write(__os, vDataValue);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__write(__os);
#else
    ::InfoProcess::IPSObject::__write(__os);
#endif
}

void
InfoProcess::IPSItemState::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(szItemID);
    __is->read(lTimeStamp);
    __is->read(nQuality);
    __is->read(::InfoProcess::__patch__VariantPtr, &vDataValue);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    IPSObject::__read(__is, true);
#else
    ::InfoProcess::IPSObject::__read(__is, true);
#endif
}

void
InfoProcess::IPSItemState::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSItemState was not generated with stream support";
    throw ex;
}

void
InfoProcess::IPSItemState::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type InfoProcess::IPSItemState was not generated with stream support";
    throw ex;
}

class __F__InfoProcess__IPSItemState : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
	assert(type == ::InfoProcess::IPSItemState::ice_staticId());
	return new ::InfoProcess::IPSItemState;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__InfoProcess__IPSItemState_Ptr = new __F__InfoProcess__IPSItemState;

const ::Ice::ObjectFactoryPtr&
InfoProcess::IPSItemState::ice_factory()
{
    return __F__InfoProcess__IPSItemState_Ptr;
}

class __F__InfoProcess__IPSItemState__Init
{
public:

    __F__InfoProcess__IPSItemState__Init()
    {
	::IceInternal::factoryTable->addObjectFactory(::InfoProcess::IPSItemState::ice_staticId(), ::InfoProcess::IPSItemState::ice_factory());
    }

    ~__F__InfoProcess__IPSItemState__Init()
    {
	::IceInternal::factoryTable->removeObjectFactory(::InfoProcess::IPSItemState::ice_staticId());
    }
};

static __F__InfoProcess__IPSItemState__Init __F__InfoProcess__IPSItemState__i;

#ifdef __APPLE__
extern "C" { void __F__InfoProcess__IPSItemState__initializer() {} }
#endif

void 
InfoProcess::__patch__IPSItemStatePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::InfoProcess::IPSItemStatePtr* p = static_cast< ::InfoProcess::IPSItemStatePtr*>(__addr);
    assert(p);
    *p = ::InfoProcess::IPSItemStatePtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::InfoProcess::IPSItemState::ice_staticId();
	throw e;
    }
}

bool
InfoProcess::operator==(const ::InfoProcess::IPSItemState& l, const ::InfoProcess::IPSItemState& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator!=(const ::InfoProcess::IPSItemState& l, const ::InfoProcess::IPSItemState& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<(const ::InfoProcess::IPSItemState& l, const ::InfoProcess::IPSItemState& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
InfoProcess::operator<=(const ::InfoProcess::IPSItemState& l, const ::InfoProcess::IPSItemState& r)
{
    return l < r || l == r;
}

bool
InfoProcess::operator>(const ::InfoProcess::IPSItemState& l, const ::InfoProcess::IPSItemState& r)
{
    return !(l < r) && !(l == r);
}

bool
InfoProcess::operator>=(const ::InfoProcess::IPSItemState& l, const ::InfoProcess::IPSItemState& r)
{
    return !(l < r);
}
