///////////////////////////////////////////////////////////////////////////////
//  Ȩ      : Ȩ (C) Ƽ޹˾
//  ļ    : VariantI.h
//        : 
//  汾      : V1.0
//        : 2006-03-16
//        : 
//              ļVariantϵࡣ
//        : 
//              VariantfromByteSeqtoByteSeq
//
///////////////////////////////////////////////////////////////////////////////
#ifndef VARIANT_H__
#define VARIANT_H__

#include "common/Common.h"
#include "common/CommonDef.h"
#include "IPSServer/IPSVariant.h"
#include "IPSServer/IPSServer.h"


///////////////////////////////////////////////////////////////////////////////
//ռ
using IceUtil::Base64;
using namespace InfoProcess;


///////////////////////////////////////////////////////////////////////////////
//        : VariantBooleanI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantBooleanַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantBooleanI : public VariantBoolean  
{
public:
    //캯
    VariantBooleanI();
    //
    ~VariantBooleanI();
    
    //ַָתõVariantBoolean
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	//VariantBooleanתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());
	
    //ָֽתõVariantBoolean
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantBooleanתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
	
    //֧boolĸֵ
    inline VariantBooleanI& operator=(const bool& v)
    {
        value = v;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantBooleanI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantBooleanI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantByteI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantByteַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantByteI : public InfoProcess::VariantByte
{
public:
    //캯
    VariantByteI();
    //
    ~VariantByteI();
    
    //ַָתõVariantByte
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	//VariantByteתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantByte
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantByteתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
	
    //֧boolĸֵ
    inline VariantByteI& operator=(const ::Ice::Byte& v)
    {
        value = v;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantByteI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    //!=
    //inline bool operator!=(const VariantByteI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantShortI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantShortַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantShortI : public InfoProcess::VariantShort
{
public:
    //캯
    VariantShortI();
    //
    ~VariantShortI();
    
    //ַָתõVariantShort
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	
    //VariantShortתõַ
    inline virtual std::string          toString(const ::Ice::Current& = ::Ice::Current());
    //ָֽתõVariantShort
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantShortתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    //֧Shortĸֵ
    inline VariantShortI& operator=(const ::Ice::Short& v)
    {
        value = v;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantShortI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    //!=
    //inline bool operator!=(const VariantShortI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};



///////////////////////////////////////////////////////////////////////////////
//        : VariantIntI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantIntַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantIntI : public InfoProcess::VariantInt
{
public:
    //캯
    VariantIntI();
    //
    ~VariantIntI();
    
    //ַָתõVariantInt
    inline virtual ::Ice::Int           fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	//VariantIntתõַ
    inline virtual std::string          toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantInt
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantIntתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
	
    //֧Intĸֵ
    inline VariantIntI& operator=(const ::Ice::Int& v)
    {
        value = v;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantIntI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    //!=
    //inline bool operator!=(const VariantIntI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantLongI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantLongַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantLongI : public InfoProcess::VariantLong
{
public:
    //캯
    VariantLongI();
    //
    ~VariantLongI();
    
    //ַָתõVariantLong
    inline virtual ::Ice::Int           fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	//VariantLongתõַ
    inline virtual std::string          toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantLong
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantLongתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
	
    //֧Longĸֵ
    inline VariantLongI& operator=(const ::Ice::Long& l)
    {
        value = l;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantLongI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    //!=
    //inline bool operator!=(const VariantLongI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};

///////////////////////////////////////////////////////////////////////////////
//        : VariantFloatI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantFloatַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantFloatI : public InfoProcess::VariantFloat
{
public:
    //캯
    VariantFloatI();
    //
    ~VariantFloatI();
    
    //ַָתõVariantFloat
    inline virtual ::Ice::Int           fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	//VariantFloatתõַ
    inline virtual std::string          toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantFloat
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantFloatתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
	
    //֧Floatĸֵ
    inline VariantFloatI& operator=(const ::Ice::Float& v)
    {
        value = v;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantFloatI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    //!=
    //inline bool operator!=(const VariantFloatI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());

};

///////////////////////////////////////////////////////////////////////////////
//        : VariantDoubleI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantDoubleַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantDoubleI : public InfoProcess::VariantDouble
{
public:
    //캯
    VariantDoubleI();
    //
    ~VariantDoubleI();
    
    //ַָתõVariantDouble
    inline virtual ::Ice::Int           fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
	//VariantDoubleתõַ
    inline virtual std::string          toString(const ::Ice::Current& = ::Ice::Current());
   
    //ָֽתõVariantDouble
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantDoubleתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
	
    //֧Doubleĸֵ
    inline VariantDoubleI& operator=(const ::Ice::Double& v)
    {
        value = v;
        return *this;
    }
    ////==
    //inline bool operator==(const VariantDoubleI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    //!=
    //inline bool operator!=(const VariantDoubleI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());

};



///////////////////////////////////////////////////////////////////////////////
//        : VariantStringI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantStringַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantStringI : public InfoProcess::VariantString
{
public:
    //캯
    VariantStringI();
    //
    ~VariantStringI();

    //ַָתõVariantString
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
    //VariantStringתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantString
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantStringתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    //֧Stringĸֵ
    //inline VariantStringI& operator=(const ::std::string& v)
    //{
    //    value = v;
    //    return *this;
    //}
    ////==
    //inline bool operator==(const VariantStringI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantStringI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantCStringI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantCStringַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantCStringI : public InfoProcess::VariantCString
{
public:
    //캯
    VariantCStringI();
    //
    ~VariantCStringI();

    //ַָתõVariantCString
    inline virtual ::Ice::Int           fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantCStringתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantCString
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantCStringתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    ////֧ByteSeqĸֵ
    //inline VariantCStringI& operator=(const ::Ice::ByteSeq& v)
    //{
    //    value = v;
    //    return *this;
    //}
    ////==
    //inline bool operator==(const VariantCStringI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantCStringI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantBlobI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantBlobַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantBlobI : public InfoProcess::VariantBlob
{
public:
    //캯
    VariantBlobI();
    //
    ~VariantBlobI();

    //ַָתõVariantBlob
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
    //VariantBlobתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantBlob
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantBlobתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    ////֧ByteSeqĸֵ
    //inline VariantBlobI& operator=(const ::Ice::ByteSeq& v)
    //{
    //    value = v;
    //    return *this;
    //}
    ////==
    //inline bool operator==(const VariantBlobI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantBlobI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantTimeI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantTimeַ֮ת
//              ֵIPS_DATESTRING_FORMATָĸʽ
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantTimeI : public InfoProcess::VariantTime
{
public:
    //캯
    VariantTimeI();
    //
    ~VariantTimeI();

    //ַָתõVariantTime
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
    //VariantTimeתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantTime
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantTimeתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    ////֧Stringĸֵ
    //inline VariantTimeI& operator=(const ::std::string& v)
    //{
    //    value = v;
    //    return *this;
    //}
    ////==
    //inline bool operator==(const VariantTimeI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantTimeI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantShortVecI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantShortVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantShortVecI : public InfoProcess::VariantShortVec
{
public:
    //캯
    VariantShortVecI();
    //
    ~VariantShortVecI();

    //ַָתõVariantShortVec
    inline virtual ::Ice::Int fromString
                                 (
                                    const ::std::string& s, 
                                    const ::Ice::Current& = ::Ice::Current()
                                 );
    //VariantShortVecתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantShortVec
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantShortVecתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    //֧ShortSeqĸֵ
    //inline VariantShortVecI& operator=(const ::Ice::ShortSeq& v)
    //{
    //    value = v;
    //    return *this;
    //}
    ////==
    //inline bool operator==(const VariantShortVecI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantShortVecI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantIntVecI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantIntgVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantIntVecI : public InfoProcess::VariantIntVec
{
public:
    //캯
    VariantIntVecI();
    //
    ~VariantIntVecI();

    //ַָתõVariantIntgVec
    inline virtual ::Ice::Int fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantIntgVecתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantIntgVec
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantIntgVecתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    //֧IntSeqĸֵ
    inline VariantIntVecI& operator=(const ::Ice::IntSeq& v)
    {
        value = v;
        return *this;
    }
    //֧IntSeqĸֵ
    inline VariantIntVecI& operator=(const Ice::Int v[])
    {
        long lLen;      //ĳ

        lLen = sizeof(v);
        value.resize( lLen / sizeof(Ice::Int) );

        memcpy
        (
            (unsigned char*)(&value[0]),
            (unsigned char*)(&v[0]),
            lLen
        );
        
        return *this;
    }
    ////==
    //inline bool operator==(const VariantIntVecI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantIntVecI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};



///////////////////////////////////////////////////////////////////////////////
//        : VariantLongVecI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantLongVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantLongVecI : public InfoProcess::VariantLongVec
{
public:
    //캯
    VariantLongVecI();
    //
    ~VariantLongVecI();

    //ַָתõVariantLongVec
    inline virtual ::Ice::Int fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantLongVecתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantLongVec
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantLongVecתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());

    //֧LongSeqĸֵ
    inline VariantLongVecI& operator=(const ::Ice::LongSeq& v)
    {
        value = v;
        return *this;
    }
    //֧LongSeqĸֵ
    inline VariantLongVecI& operator=(const Ice::Long v[])
    {
        long lLen;      //ĳ
        
        lLen = sizeof(v);
        value.resize( lLen / sizeof(Ice::Long) );
        
        memcpy
        (
            (unsigned char*)(&value[0]),
            (unsigned char*)(&v[0]),
            lLen * sizeof(Ice::Long)
        );
        
        return *this;
    }
    ////==
    //inline bool operator==(const VariantLongVecI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantLongVecI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};



///////////////////////////////////////////////////////////////////////////////
//        : VariantFloatVecI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantFloatVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantFloatVecI : public InfoProcess::VariantFloatVec
{
public:
    //캯
    VariantFloatVecI();
    //
    ~VariantFloatVecI();

    //ַָתõVariantFloatVec
    inline virtual ::Ice::Int fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantFloatVecתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantFloatVec
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantFloatVecתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());

    //֧FloatSeqĸֵ
    inline VariantFloatVecI& operator=(const ::Ice::FloatSeq& v)
    {
        value = v;
        return *this;
    }
    //֧FloatSeqĸֵ
    inline VariantFloatVecI& operator=(const Ice::Float v[])
    {
        long lLen;      //ĳ
        
        lLen = sizeof(v);
        value.resize( lLen / sizeof(Ice::Float) );
        
        memcpy
        (
            (unsigned char*)(&value[0]),
            (unsigned char*)(&v[0]),
            lLen * sizeof(Ice::Float)
        );
        
        return *this;
    }
    ////==
    //inline bool operator==(const VariantFloatVecI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantFloatVecI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};



///////////////////////////////////////////////////////////////////////////////
//        : VariantDoubleVecI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantDoubleVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantDoubleVecI : public InfoProcess::VariantDoubleVec
{
public:
    //캯
    VariantDoubleVecI();
    //
    ~VariantDoubleVecI();

    //ַָתõVariantDoubleVec
    inline virtual ::Ice::Int fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantDoubleVecתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());

    //ָֽתõVariantDoubleVec
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantDoubleVecתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    //֧DoubleSeqĸֵ
    inline VariantDoubleVecI& operator=(const ::Ice::DoubleSeq& v)
    {
        value = v;
        return *this;
    }
    //֧DoubleSeqĸֵ
    inline VariantDoubleVecI& operator=(const Ice::Double v[])
    {
        long lLen;      //ĳ
        
        lLen = sizeof(v);
        value.resize( lLen / sizeof(Ice::Double) );
        
        memcpy
        (
            (unsigned char*)(&value[0]),
            (unsigned char*)(&v[0]),
            lLen
        );
        
        return *this;
    }
    ////==
    //inline bool operator==(const VariantDoubleVecI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantDoubleVecI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};


///////////////////////////////////////////////////////////////////////////////
//        : VariantVarVecI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantVarVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantVarVecI : public InfoProcess::VariantVarVec
{
public:
    //캯
    VariantVarVecI();
    //
    ~VariantVarVecI();
    
    //ַָתõVariantVarVec
    inline virtual ::Ice::Int fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantVarVecתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantVarVec
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    //VariantVarVecתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    //֧VariantVarĸֵ
    inline VariantVarVecI& operator=(const ::InfoProcess::VariantVarVec& v)
    {
        //value = v;
        return *this;
    }
    
    //֧VariantVarĸֵ
    //inline VariantVarVecI& operator=(const Ice::Variant v[])
    //{
    //    long lLen;      //ĳ

    //    lLen = sizeof(v);
    //    value.resize( lLen / sizeof(Ice::Double) );
    //    
    //    memcpy
    //    (
    //        (unsigned char*)(&value[0]),
    //        (unsigned char*)(&v[0]),
    //        lLen
    //    );

    //    return *this;
    //}
    //==
    //inline bool operator==(const VariantVarVecI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantVarVecI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};




///////////////////////////////////////////////////////////////////////////////
//        : VariantVarMapI
//        : 
//  汾      : V1.0
//        : 2006-06-13
//    : 
//              ʵVariantMapVecַ֮ת
//        : 
///////////////////////////////////////////////////////////////////////////////
class VariantVarMapI : public InfoProcess::VariantVarMap
{
public:
    //캯
    VariantVarMapI();
    //
    ~VariantVarMapI();

    //ַָתõVariantVarMap
    inline virtual ::Ice::Int fromString
    (
        const ::std::string& s, 
        const ::Ice::Current& = ::Ice::Current()
    );
    
    //VariantVarMapתõַ
    inline virtual std::string toString(const ::Ice::Current& = ::Ice::Current());
    
    //ָֽתõVariantVarMap
    inline virtual ::Ice::Int fromByteSeq
    (
        const ::Ice::ByteSeq& bq, 
        const ::Ice::Current& = ::Ice::Current()
    );
    
    //VariantVarMapתõֽ
    inline virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current());
    
    ////֧VariantVarMapĸֵ
    //inline VariantVarMapI& operator=(const ::InfoProcess::VariantVarMap& v)
    //{
    //    //value = v;
    //    return *this;
    //}
    ////==
    //inline bool operator==(const VariantVarMapI& vVar) const
    //{
    //    return ( vVar.value == value);
    //}
    ////!=
    //inline bool operator!=(const VariantVarMapI& vVar) const
    //{
    //    return ( vVar.value != value);
    //}
    
    ////֧VariantVarMapĸֵ
    //inline VariantVarMapI& operator=(const Ice::VariantVarMap v[])
    //{
    //    long lLen;      //ĳ
    //    lLen = sizeof(v);
    //    value.resize( lLen / sizeof(Ice::Double) );
    //    
    //    memcpy
    //    (
    //        (unsigned char*)(&value[0]),
    //        (unsigned char*)(&v[0]),
    //        lLen
    //    );
    //    
    //    return *this;
    //}
    //صǰ
    inline virtual InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current());
};













///////////////////////////////////////////////////////////////////////////////
//  :   isVariantEqual
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-09-11
//  :
//              p1                      ---    ȱȽϵVariantָ1
//              p2                      ---    ȱȽϵVariantָ2
//              
//  :   
//              
//              
// ֵ   :   ֵ
//              true                    ---     ֵָָ
//              false                   ---     ֵָָ
//              
// ˵ :   
//              VariantVarMapVariant
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline bool isVariantEqual(const InfoProcess::VariantPtr& p1, const InfoProcess::VariantPtr& p2)
{
    InfoProcess::VARTYPE vt;
    
    vt = p1->getType();
    if ( p2->getType() != vt )
    {
        return false;
    }
    
    switch(vt)
    {
    case InfoProcess::VTBOOL:
        {
            InfoProcess::VariantBooleanPtr p11 = NULL;
            InfoProcess::VariantBooleanPtr p21 = NULL;
            p11 = InfoProcess::VariantBooleanPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantBooleanPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTBYTE:
        {
            InfoProcess::VariantBytePtr p11 = NULL;
            InfoProcess::VariantBytePtr p21 = NULL;
            p11 = InfoProcess::VariantBytePtr::dynamicCast(p1);
            p21 = InfoProcess::VariantBytePtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTSHORT:
        {
            InfoProcess::VariantShortPtr p11 = NULL;
            InfoProcess::VariantShortPtr p21 = NULL;
            p11 = InfoProcess::VariantShortPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantShortPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTINT:
        {
            InfoProcess::VariantIntPtr p11 = NULL;
            InfoProcess::VariantIntPtr p21 = NULL;
            p11 = InfoProcess::VariantIntPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantIntPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTLONG:
        {
            InfoProcess::VariantLongPtr p11 = NULL;
            InfoProcess::VariantLongPtr p21 = NULL;
            p11 = InfoProcess::VariantLongPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantLongPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTFLOAT:
        {
            InfoProcess::VariantFloatPtr p11 = NULL;
            InfoProcess::VariantFloatPtr p21 = NULL;
            p11 = InfoProcess::VariantFloatPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantFloatPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTDOUBLE:
        {
            InfoProcess::VariantDoublePtr p11 = NULL;
            InfoProcess::VariantDoublePtr p21 = NULL;
            p11 = InfoProcess::VariantDoublePtr::dynamicCast(p1);
            p21 = InfoProcess::VariantDoublePtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTSTRING:
        {
            InfoProcess::VariantStringPtr p11 = NULL;
            InfoProcess::VariantStringPtr p21 = NULL;
            p11 = InfoProcess::VariantStringPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantStringPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTCSTRING:
        {
            InfoProcess::VariantCStringPtr p11 = NULL;
            InfoProcess::VariantCStringPtr p21 = NULL;
            p11 = InfoProcess::VariantCStringPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantCStringPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTBLOB:
        {
            InfoProcess::VariantBlobPtr p11 = NULL;
            InfoProcess::VariantBlobPtr p21 = NULL;
            p11 = InfoProcess::VariantBlobPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantBlobPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTTIME:
        {
            InfoProcess::VariantTimePtr p11 = NULL;
            InfoProcess::VariantTimePtr p21 = NULL;
            p11 = InfoProcess::VariantTimePtr::dynamicCast(p1);
            p21 = InfoProcess::VariantTimePtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTSHORTVEC:
        {
            InfoProcess::VariantShortVecPtr p11 = NULL;
            InfoProcess::VariantShortVecPtr p21 = NULL;
            p11 = InfoProcess::VariantShortVecPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantShortVecPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTINTVEC:
        {
            InfoProcess::VariantIntVecPtr p11 = NULL;
            InfoProcess::VariantIntVecPtr p21 = NULL;
            p11 = InfoProcess::VariantIntVecPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantIntVecPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTLONGVEC:
        {
            InfoProcess::VariantLongVecPtr p11 = NULL;
            InfoProcess::VariantLongVecPtr p21 = NULL;
            p11 = InfoProcess::VariantLongVecPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantLongVecPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTFLOATVEC:
        {
            InfoProcess::VariantFloatVecPtr p11 = NULL;
            InfoProcess::VariantFloatVecPtr p21 = NULL;
            p11 = InfoProcess::VariantFloatVecPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantFloatVecPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTDOUBLEVEC:
        {
            InfoProcess::VariantDoubleVecPtr p11 = NULL;
            InfoProcess::VariantDoubleVecPtr p21 = NULL;
            p11 = InfoProcess::VariantDoubleVecPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantDoubleVecPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTVARVEC:
        {
            InfoProcess::VariantVarVecPtr p11 = NULL;
            InfoProcess::VariantVarVecPtr p21 = NULL;
            p11 = InfoProcess::VariantVarVecPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantVarVecPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    case InfoProcess::VTVARMAP:
        {
            InfoProcess::VariantVarMapPtr p11 = NULL;
            InfoProcess::VariantVarMapPtr p21 = NULL;
            p11 = InfoProcess::VariantVarMapPtr::dynamicCast(p1);
            p21 = InfoProcess::VariantVarMapPtr::dynamicCast(p2);
            return ( *p11 == *p21 );
        }
    default:
        return false;
    }
    
}
















#endif // "#ifndef VARIANT_H__"Ľ



