///////////////////////////////////////////////////////////////////////////////
//  Ȩ      : Ȩ (C) Ƽ޹˾
//  ļ    : IPSUtil.h
//        : 
//  汾      : V1.0
//        : 2006-04-29
//        : 
//              ļڰϵͳصĶ塣
//        : 
///////////////////////////////////////////////////////////////////////////////


#ifndef IPSUTIL_H__
#define IPSUTIL_H__

#include <algorithm>
#include <string>
//#include <ctime>

#ifdef _WIN32
#   include <sys/timeb.h>
#   include <time.h>
#else
#   include <sys/time.h>
#endif


///////////////////////////////////////////////////////////////////////////////
//ռ
using namespace std;


///////////////////////////////////////////////////////////////////////////////
//        : IPSUtil
//        : 
//  汾      : V1.0
//        : 2006-02-21
//    : 
//              ṩú磺ʱתdoubleֵSQLеŴ
//              ȡǰʱַ
//
//        : 
//
///////////////////////////////////////////////////////////////////////////////
class IPSUtil
{
public:
    static inline void ConvSymbol(std::string &szSrc, const std::string szFrom, const std::string szTo);
    //ֵַͬλ
    static inline int GetDiffPosFromStrs(const char* pszStr1, const char *pszStr2);
    //ֵַͬλ
    static inline int GetSamePosFromStrs(const char* pszStr1, const char *pszStr2);
    //SQLֵֶеĵŴ˫
    static inline std::string DealSQLComma(const std::string& sSQLValue);
    //ĿIDеĵš.Ŀ
    static inline int CountPointCharNum(const std::string& sItemID);
    //ȡǰʱַ(׼ʽ)
    static inline std::string GetCurrTimeStr();
    //ָʱֵ(1970-01-01 00:00:00ʼΪλʱֵ)תʱַ
    static inline std::string GetTimeStrFromSecVal(const long long& lSeconds);
    //ָʱֵ(1970-01-01 00:00:00ʼ΢Ϊλʱֵ)תʱַ
    static inline std::string GetTimeStrFromusVal(const long long& lus);
    //ȡǰʱַ(ոʽ)
    static inline std::string GetCurrTimeCompactStr();
    //ַмͷβոĴ
    static inline std::string sTrimmedString(const string& sSrc);
    //Fortranؿոԭַ
    static inline std::string sFortranTrim(const string& sSrc);
    //
    static inline vector<string> String2StrSeq(const char& cSep, const string& sOriginal);
};

///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::sTrimmedString
// ǰ汾 :   V1.0
//      :   wjy
//  :   2007-02-03
//  :
//              sSrc        ---     мͷβոԭַ
//              
//  :   
//              
//
// ֵ   :   ַ
//              мͷβոַ
//              
// ˵ :   
//              ַмͷβոĴ
//              
// ޸ʷ :   
//              
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::sTrimmedString(const string& sSrc)
{
    const char                      cnCharBlank = ' ';  //ոַ
    basic_string <char>::size_type  itStart, itEnd;
    
    itStart = sSrc.find_first_not_of(cnCharBlank);
    itEnd   = sSrc.find_last_not_of(cnCharBlank);
    
    //ȫǿո
    if( string::npos == itEnd )
    { 
        return "";
    }
    
    //ؼͷβĿոַ
    return sSrc.substr(itStart,(itEnd-itStart+1));      
}



///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::sFortranTrim
// ǰ汾 :   V1.0
//      :   wjy
//  :   2007-02-03
//  :
//              sSrc        ---     Fortranؿոԭַ
//              
//  :   
//              
//
// ֵ   :   ַ
//              ͷոַַ֮ټӵһոʼַ
//              
// ˵ :   
//              ַFortranؿոԭַ
//              
// ޸ʷ :   
//              
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::sFortranTrim(const string& sSrc)
{
    const char                      cnCharBlank = ' ';  //ոַ
    basic_string <char>::size_type  itStart, itEnd;

    itStart = sSrc.find_first_not_of(cnCharBlank);
    itEnd   = sSrc.find_first_of(cnCharBlank,itStart);
    
    //ȫǿո
    if( string::npos == itStart )
    { 
        return "";
    }

    //ûпո
    if( string::npos == itEnd)
    {
        return sSrc.substr(itStart);
    }
    
    //ؼͷβĿոַ
    return sSrc.substr(itStart,(itEnd-itStart+1));      
}

///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::String2StrSeq
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-12-20
//  :
//              cSep        ---     ַеķָ
//              sOriginal   ---     ԭʼַ
//              
//  :   
//              
//
// ֵ   :   ַ
//              
//              
// ˵ :   
//              ԭʼַݷַָָ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline vector<string> IPSUtil::String2StrSeq(const char& cSep, const string& sOriginal)
{
    char            *token = NULL;
    vector<string>  sSeq;
    
    // Establish string and get the first token:
    token = strtok( (char*)sOriginal.c_str(), &cSep );
    
    while( NULL != token )
    {
        // ַλ֮ǰַѹ뵽
        sSeq.push_back(token);
        
        //õһָλ
        token = strtok( NULL, &cSep );
    }
    
    return sSeq;
}




///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::GetTimeStrFromusVal
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              lus         ---     1970-01-01 00:00:00ʼʱ΢ֵ
//              
//  :   
//              
//
// ֵ   :   ַ
//              ǰʱı׼ʽַ
//              
// ˵ :   
//              صǰʱı׼ʽַ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::GetTimeStrFromusVal(const long long& lus)
{
    time_t      tim = lus / 1000000;
    long long   us  = lus % 1000000;
    
    struct tm* t = NULL;
#ifdef _WIN32
    t = localtime(&tim);
#else
    struct tm tr;
    localtime_r(&tim, &tr);
    t = &tr;
#endif

    //cеstrtime
    //char buf[32];
    //strftime(buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", t);
    //
    //return buf;

    ostringstream os;
    os.fill('0');
    os.widen(4);
    os << (t->tm_year+TIME_YEAR_BASE) << "-";               //Ǵ1900Ϊ0꿪ʼ
    os.width(2);
    os << (t->tm_mon+TIME_MONTH_BASE) << "-";               //·Ǵֵ0ʼ
    os.width(2);
    os << t->tm_mday << " ";
    os.width(2);
    os << t->tm_hour << ":";
    os.width(2);
    os << t->tm_min << ":";
    os.width(2);
    os << t->tm_sec;
    os << "." << us;

    return os.str();
}


///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::GetTimeStrFromSecVal
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              lSeconds    ---     1970-01-01 00:00:00ʼʱֵ
//              
//  :   
//              
//
// ֵ   :   ַ
//              ǰʱı׼ʽַ
//              
// ˵ :   
//              صǰʱı׼ʽַ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::GetTimeStrFromSecVal(const long long& lSeconds)
{
    time_t tim =  lSeconds;
    
    struct tm* t = NULL;
#ifdef _WIN32
    t = localtime(&tim);
#else
    struct tm tr;
    localtime_r(&tim, &tr);
    t = &tr;
#endif

    //cеstrtime
    //char buf[32];
    //strftime(buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", t);
    //
    //return buf;

    ostringstream os;
    os.fill('0');
    os.widen(4);
    os << (t->tm_year+TIME_YEAR_BASE) << "-";               //Ǵ1900Ϊ0꿪ʼ
    os.width(2);
    os << (t->tm_mon+TIME_MONTH_BASE) << "-";               //·Ǵֵ0ʼ
    os.width(2);
    os << t->tm_mday << " ";
    os.width(2);
    os << t->tm_hour << ":";
    os.width(2);
    os << t->tm_min << ":";
    os.width(2);
    os << t->tm_sec;

    return os.str();
}


///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::GetCurrTimeStr
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              
//              
//  :   
//              
//
// ֵ   :   ַ
//              ǰʱı׼ʽַ
//              
// ˵ :   
//              صǰʱı׼ʽַ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::GetCurrTimeStr()
{
    //std::string sCurrTime;
    //time_t      szClock;
    //struct tm   *newTime;
    //
    //time( &szClock );
    //newTime   = localtime( &szClock );
    //sCurrTime = asctime( newTime );
    //sCurrTime += ": ";
    //return sCurrTime;
    
    time_t tim;
    time( &tim );
    
    struct tm* t = NULL;
#ifdef _WIN32
    t = localtime(&tim);
#else
    struct tm tr;
    localtime_r(&tim, &tr);
    t = &tr;
#endif
    
    //cеstrtime
    //char buf[32];
    //strftime(buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", t);
    //
    //return buf;
    
    ostringstream os;
    os.fill('0');
    os.widen(4);
    os << (t->tm_year+TIME_YEAR_BASE) << "-";               //Ǵ1900Ϊ0꿪ʼ
    os.width(2);
    os << (t->tm_mon+TIME_MONTH_BASE) << "-";               //·Ǵֵ0ʼ
    os.width(2);
    os << t->tm_mday << " ";
    os.width(2);
    os << t->tm_hour << ":";
    os.width(2);
    os << t->tm_min << ":";
    os.width(2);
    os << t->tm_sec;
    
    return os.str();
}


///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::GetCurrTimeCompactStr
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              
//              
//  :   
//              
//
// ֵ   :   ַ
//              ǰʱĽոʽַ
//              
// ˵ :   
//              صǰʱĽոʽַ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::GetCurrTimeCompactStr()
{
    //std::string sCurrTime;
    //time_t      szClock;
    //struct tm   *newTime;
    //
    //time( &szClock );
    //newTime   = localtime( &szClock );
    //sCurrTime = asctime( newTime );
    //sCurrTime += ": ";
    //return sCurrTime;

    time_t tim;
    time( &tim );

    struct tm* t = NULL;
#ifdef _WIN32
    t = localtime(&tim);
#else
    struct tm tr;
    localtime_r(&tim, &tr);
    t = &tr;
#endif

    //cеstrtime
    //char buf[32];
    //strftime(buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", t);
    //
    //return buf;

    ostringstream os;
    os.fill('0');
    os.widen(4);
    os << (t->tm_year+TIME_YEAR_BASE);               //Ǵ1900Ϊ0꿪ʼ
    os.width(2);
    os << (t->tm_mon+TIME_MONTH_BASE);               //·Ǵֵ0ʼ
    os.width(2);
    os << t->tm_mday;
    os.width(2);
    os << t->tm_hour;
    os.width(2);
    os << t->tm_min;
    os.width(2);
    os << t->tm_sec;

    return os.str();
}

///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::CountPointCharNum
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              sItemID         ---     ĿIDַ
//              
//  :   
//              
//
// ֵ   :   
//              ĿIDַIPS_CHR_POINTŵĿ
//              
// ˵ :   
//              ĿIDеĵš.Ŀ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline int IPSUtil::CountPointCharNum(const std::string& sItemID)
{
    return count_if(sItemID.begin(),sItemID.end(),bind2nd(equal_to<char>(), IPS_CHR_POINT));
}


///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::DealSQLComma
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              sSQLValue       ---     SQLеֶεֵ
//              
//  :   
//              
//
// ֵ   :   string
//              ַкеţеÿźһţ
//              任õĽ
//              
// ˵ :   
//              SQLֵֶеĵŴ˫
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline std::string IPSUtil::DealSQLComma(const std::string& sSQLValue)
{
    //replace_if(sSQLValue.begin(),sSQLValue.end(),bind2nd(equal_to<char>(), '\''),'\"');
    string                          sVal;
    basic_string <char>::size_type  it;
    
    sVal = sSQLValue;
    it   = sVal.find(IPS_CHR_COMMA);
    while ( string::npos != it )
    {
        sVal.insert(it, IPS_PTR_CHR_COMMA);
        it++;
        it++;
        it = sVal.find(IPS_CHR_COMMA, it);
    }
    return sVal;
}

///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::GetDiffPosFromStrs
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              pszStr1         ---     ַ1
//              pszStr2         ---     ַ2
//              
//  :   
//              
//
// ֵ   :   int
//              õַַһβͬλ
//              ֵΪ-1ʾ޲ַͬ
//              
// ˵ :   
//              õַַһβͬλ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline int IPSUtil::GetDiffPosFromStrs(const char *pszStr1, const char *pszStr2)
{
    unsigned int pos = 0;
    unsigned int len1;
    unsigned int len2;
    
    len1 = strlen(pszStr1);
    len2 = strlen(pszStr2);
    
    while(true)
    {
        if( ( len1 <= pos ) ||  ( len2 <= pos ) )
        {
            if( len1 == len2 )
            {
                //ѾȽ
                return -1;
            }
            else
            {
                //ĳַѾȽ
                return pos;
            }
        }
        
        if( *(pszStr1 + pos) != *(pszStr2 + pos) )
        {
            //ͬλõַͬ
            return pos;
        }

        pos++;
    }
    
}


///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::ConvSymbol
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              szSrc           ---     ַ
//              szFrom          ---     滻ַ
//              szTo            ---     滻ַ
//              
//  :   
//              szSrc           ---     ַ
//
// ֵ   :   
//              
//              
// ˵ :   
//              ַszSrcеַszFromתΪszTo
//              
// ޸ʷ :   
//              
//
///////////////////////////////////////////////////////////////////////////////
inline void IPSUtil::ConvSymbol(std::string &szSrc, const std::string szFrom, const std::string szTo)
{
    std::string::size_type  posStart = 0;   //ϴ滻Ľλ
    std::string::size_type  posEnd   = 0;
    std::string             szDst;          //澭滻ַ
    
    while( std::string::npos != (posEnd = szSrc.find(szFrom, posStart)) )
    {
        //һҵ滻ַϴ滻Ľλ뵱ǰҵλַַ֮
        szDst    += szSrc.substr(posStart, posEnd- posStart);
        //"ϴ滻Ľλ"
        posStart =  posEnd + szFrom.length();
        //滻ַַ
        szDst    += szTo;
    }
    //ʣµδҵ滻ַԭʼַַ
    szDst += szSrc.substr(posStart, szSrc.length() - posStart);
    //
    szSrc =  szDst;
    
    return;
}




///////////////////////////////////////////////////////////////////////////////
//  :   IPSUtil::GetSamePosFromStrs
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-06-13
//  :
//              pszStr1         ---     Ƚϵַ1
//              pszStr2         ---     Ƚϵַ1
//              
//  :   
//              
//
// ֵ   :   int
//              ַַһͬλ
//              ֵΪ-1ʾַͬ
//              
// ˵ :   
//              õַַһͬλ
//              
// ޸ʷ :   
//                         
//
///////////////////////////////////////////////////////////////////////////////
inline int IPSUtil::GetSamePosFromStrs(const char *pszStr1, const char *pszStr2)
{
    unsigned int pos = 0;

    while(1)
    {
        if
        ( 
            (strlen(pszStr1) <= pos)
            || 
            (strlen(pszStr2) <= pos) 
        )
        {
            //ĳַѾȽϣ򷵻-1
            return -1;
        }
        if( *(pszStr1 + pos) == *(pszStr2 + pos) )
        {
            //ͬλõַͬ
            return pos;
        }

        pos++;
    }

    //return pos;
}


///////////////////////////////////////////////////////////////////////////////
//        : CUserEID
//        : 
//  汾      : V1.0
//        : 2006-02-21
//    : 
//              ṩû¼ʶĴ
//
//        : 
//
///////////////////////////////////////////////////////////////////////////////
class CUserEID: public IceUtil::RWRecMutex
{
private:
    std::string   sEID;                         //ûEID
    bool          bEIDValid;                    //ûEIDǷЧ

public:
    //캯
    CUserEID();
    //
    ~CUserEID();
    
    void    SetEID(const string& sNewEID);      //EID
    string  GetEID();                           //ȡEID
    void    SetValid(const bool& bValid);       //EIDЧ
};




#endif // "#ifndef IPSUTIL_H__"Ľ


